/************************************************************************
    MeOS - Orienteering Software
    Copyright (C) 2009-2016 Melin Software HB

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

    Melin Software HB - software@melin.nu - www.melin.nu
    Eksoppsvgen 16, SE-75646 UPPSALA, Sweden

************************************************************************/
#include "stdafx.h"
#include <vector>
#include "meos_util.h"

//ABCDEFGHIJKLMNO
//V2: ABCDEFGHIHJKMN
//V31: a
//V33: abcd
int getMeosBuild() {
  string revision("$Rev: 402 $");
  return 174 + atoi(revision.substr(5, string::npos).c_str());
}

//ABCDEFGHIJKILMNOPQRSTUVXYZabcdefghijklmnopqrstuvxyz
//V2: abcdefgh
//V3: abcdefghijklmnopqrstuvxyz
//V31: abcde
//V32: abcdefgh
//V33: abcdefghij
string getMeosDate() {
  string date("$Date: 2016-03-06 10:32:44 +0100 (sö, 06 mar 2016) $");
  return date.substr(7,10);
}

string getBuildType() {
  return ""; // No parantheses (...)
}

string getMajorVersion() {
  return "3.3";
}

string getMeosFullVersion() {
  char bf[256];
  string maj = getMajorVersion();
  if (getBuildType().empty())
    sprintf_s(bf, "Version X#%s.%d, %s", maj.c_str(), getMeosBuild(), getMeosDate().c_str());
  else
    sprintf_s(bf, "Version X#%s.%d, %s %s", maj.c_str(), getMeosBuild(), getBuildType().c_str(), getMeosDate().c_str());
  return bf;
}

string getMeosCompectVersion() {
  if (getBuildType().empty())
    return getMajorVersion() + "." + itos(getMeosBuild());
  else
    return getMajorVersion() + "." + itos(getMeosBuild()) + " (" + getBuildType() + ")";
}

void getSupporters(vector<string> &supp)
{
  supp.push_back("Centrum OK");
  supp.push_back("Ove Persson, Pite IF");
  supp.push_back("OK Rodhen");
  supp.push_back("Tby Extreme Challenge");
  supp.push_back("Thomas Engberg, VK Uvarna");
  supp.push_back("Eilert Edin, Sidensj IK");
  supp.push_back("Gran Nordh, Trollhttans SK");
  supp.push_back("Roger Gustavsson, OK Tisaren");
  supp.push_back("Sundsvalls OK");
  supp.push_back("OK Gipens OL-skytte");
  supp.push_back("Helsingborgs SOK");
  supp.push_back("OK Gipens OL-skytte");
  supp.push_back("Rune Thurn, Vallentuna-sseby OL");
  supp.push_back("Roland Persson, Kalmar OK");
  supp.push_back("Robert Jessen, Frmmestads IK");
  supp.push_back("Anders Platt, Jrla Orientering");
  supp.push_back("Almby IK, rebro");
  supp.push_back("Peter Rydester, Rehns BK");
  supp.push_back("IK Hakarpspojkarna");
  supp.push_back("Rydboholms SK");
  supp.push_back("IFK Kiruna");
  supp.push_back("Peter Andersson, Sders SOL");
  supp.push_back("Bjrkfors GoIF");
  supp.push_back("OK Ziemelkurzeme");
  supp.push_back("Big Foot Orienteers");
  supp.push_back("FIF Hillerd");
  supp.push_back("Anne Udd");
  supp.push_back("OK Orinto");
  supp.push_back("SOK Trff");
  supp.push_back("Gamleby OK");
  supp.push_back("Vnersborgs SK");
  supp.push_back("Henrik Ortman, Vsters SOK");
  supp.push_back("Leif Olofsson, Sjuntorp");
  supp.push_back("Vallentuna/sseby OL");
  supp.push_back("Oskarstrm OK");
  supp.push_back("Skogslparna");
  supp.push_back("OK Milan");
  supp.push_back("GoIF Tjalve");
  supp.push_back("OK Skrmen");
  supp.push_back("stkredsen");
  supp.push_back("OK Roskilde");
  supp.push_back("Holbk Orienteringsklub");
  supp.push_back("Bodens BK");
  supp.push_back("OK Tyr, Karlstad");
  supp.push_back("Gteborg-Majorna OK");
  supp.push_back("OK Jrnbrarna, Kopparberg");
  supp.push_back("FK sen");
  supp.push_back("Ballerup OK");
  supp.push_back("Olivier Benevello, Valbonne SAO");
  supp.push_back("Tommy Whlin, OK Enen");
  supp.push_back("Hjobygdens OK");
  supp.push_back("Tisvilde Hegn OK");
  supp.push_back("Lindebygdens OK");
  supp.push_back("OK Flundrehof");
  supp.push_back("Vittjrvs IK");
  supp.push_back("Annebergs GIF");
  supp.push_back("Lars-Eric Gahlin, stersunds OK");
  supp.push_back("Sundsvalls OK:s Veteraner");
  supp.push_back("OK Skogshjortarna");
  supp.push_back("Kinnastrms SK");
  supp.push_back("OK Pan rhus");
  supp.push_back("Jan Ernberg, Tby OK");
  supp.push_back("Stjrnorps SK");
  supp.push_back("Mlndal Outdoor IF");
  supp.push_back("Roland Elg, Fjrs AIK");
  supp.push_back("Tenhults SOK");
  supp.push_back("Jrflla OK");
  supp.push_back("Lars Jonasson");
  supp.push_back("Anders Larsson, OK Nackhe");
  supp.push_back("Hans Wilhelmsson");
  supp.push_back("Patrice Lavallee, Noyon Course d'Orientation");
  supp.push_back("IFK Linkpings OS");
  supp.push_back("Lars Ove Karlsson, Vsters SOK");
  supp.push_back("OK Djerf");
  supp.push_back("OK Vivill");
  supp.push_back("IFK Mora OK");
  supp.push_back("Sonny Andersson, Huskvarna");
  supp.push_back("Hssleholms OK Skolorientering");
  supp.push_back("IBM-klubben Orientering");
  supp.push_back("OK st, Birkerd");
  supp.push_back("OK Klemmingen");
  supp.push_back("Hans Johansson");
  supp.push_back("KOB Kysak");  
  supp.push_back("Per Ivarsson, Trollhttans SOK");
}
